<?php


class wps_ic_js_delay
{

  public static $excludes;
  public static $footerScripts;

  public function __construct() {
    self::$excludes = new wps_ic_excludes();
  }


  public function printFooterScripts() {
    $html = '';

    if (!empty(self::$footerScripts)) {
      foreach (self::$footerScripts as $script) {
        $html .= $script[0];
      }
    }

    return $html . '</body>';
  }

  public function scriptsToFooter($tag) {
    $original_tag = $tag;
    if (is_array($tag)) {
      $tag = $tag[0];
    }
    if (is_array($tag)) {
      $tag = $tag[0];
    }
    if (self::$excludes->strInArray($tag, self::$excludes->scriptsToFooterExcludes())) {
      return $tag;
    }
    self::$footerScripts[] = $original_tag;
    return '';
  }


  public function preload_scripts($tag) {
    if (is_array($tag)) {
      $fullTag = $tag[0];
    }

    $tagLower = strtolower($fullTag);

    if (strpos($tagLower, 'src=') !== false) {
      $src = $tag[1];
      if(strpos($src, 'google') === false) {
        #return '<link rel="preload" href="' . $src . '" as="script">' . $fullTag;
      }
    }

    return $fullTag;
  }


  public function removeNoDelay($tag) {
    if (is_array($tag)) {
      $tag = $tag[0];
    }

    $tagLower = strtolower($tag);

    // It's excluded
    if (strpos($tagLower, 'text/javascript-no-delay') !== false) {
      $tag = str_replace('type="text/javascript-no-delay"', 'type="text/javascript"', $tag);
    }

    return $tag;
  }


  public function delay_script_replace($tag) {

    if (!empty($_GET['removeScripts'])) {
      return '';
    }

    if (is_array($tag)) {
      $tag = $tag[0];
    }

    $tagLower = strtolower($tag);

    if (strpos($tagLower, 'document.write') !== false) {
      $tag = str_replace('type="text/javascript-no-delay"', 'type="text/javascript"', $tag);
      return $tag;
    }

    // It's excluded
    if (strpos($tagLower, 'text/javascript-no-delay') !== false || strpos($tagLower, 'aio-js-extra')) {
      $tag = str_replace('type="text/javascript-no-delay"', 'type="text/javascript"', $tag);
      return $tag;
    }

    // It's inline
    if (strpos($tagLower, 'src=') === false) {

      if (strpos($tagLower, 'type=') === false) {
        $tag = str_replace('<script', '<script type="wpc-delay-script"', $tag);
      } else {
        $tag = str_replace('type="text/javascript"', 'type="wpc-delay-script"', $tag);
        $tag = str_replace("type='text/javascript'", "type='wpc-delay-script'", $tag);
      }

    } else {
      if (strpos($tagLower, 'googletag') || strpos($tagLower, 'gtag')) {
        $tag = str_replace('async', '', $tag);
        $tag = str_replace('<script', '<script async', $tag);
      } elseif (strpos($tagLower, 'type=') === false) {
        $tag = str_replace('<script', '<script type="wpc-delay-script"', $tag);
      } else {
        $tag = str_replace('type="text/javascript"', 'type="wpc-delay-script"', $tag);
        $tag = str_replace("type='text/javascript'", "type='wpc-delay-script'", $tag);
      }

    }

    return $tag;
  }


}